"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngxFirebaseWebAuthn = void 0;
const tslib_1 = require("tslib");
const server_1 = require("@simplewebauthn/server");
const auth_1 = require("firebase-admin/auth");
const firestore_1 = require("firebase-admin/firestore");
const firebase_functions_1 = require("firebase-functions");
exports.ngxFirebaseWebAuthn = (0, firebase_functions_1.runWith)({
    enforceAppCheck: true,
})
    .https
    .onCall((functionRequest, callableContext) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        return functionRequest.operation === "clear challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _j, _k;
            return userDocument ? userDocument.challenge ? userDocument.credentialId && userDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_j = callableContext.auth) === null || _j === void 0 ? void 0 : _j.uid) || "").update({
                challenge: firestore_1.FieldValue.delete(),
            }).then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_k = callableContext.auth) === null || _k === void 0 ? void 0 : _k.uid) || "").delete().then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            } : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "clear user doc" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _l;
            return userDocument ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_l = callableContext.auth) === null || _l === void 0 ? void 0 : _l.uid) || "").delete().then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "create authentication challenge" ? ((publicKeyCredentialRequestOptionsJSON) => {
            var _a;
            return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                challenge: publicKeyCredentialRequestOptionsJSON.challenge,
            }, {
                merge: true,
            }).then(() => ({
                requestOptions: publicKeyCredentialRequestOptionsJSON,
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            }));
        })((0, server_1.generateAuthenticationOptions)({
            rpID: callableContext.rawRequest.hostname,
            userVerification: "required",
        })) : functionRequest.operation === "create reauthentication challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_c = callableContext.auth) === null || _c === void 0 ? void 0 : _c.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? ((publicKeyCredentialRequestOptions) => {
                var _a;
                return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                    challenge: publicKeyCredentialRequestOptions.challenge,
                }, {
                    merge: true,
                }).then(() => ({
                    requestOptions: publicKeyCredentialRequestOptions,
                    operation: functionRequest.operation,
                    success: true,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })((0, server_1.generateAuthenticationOptions)({
                allowCredentials: [
                    {
                        id: userDocument.credentialId,
                        type: "public-key",
                    },
                ],
                rpID: callableContext.rawRequest.hostname,
                userVerification: "required",
            })) : {
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            } : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "create registration challenge" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_d = callableContext.auth) === null || _d === void 0 ? void 0 : _d.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _m;
            return !(userDocument === null || userDocument === void 0 ? void 0 : userDocument.credentialPublicKey) ? ((publicKeyCredentialCreationOptions) => {
                var _a;
                return firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                    challenge: publicKeyCredentialCreationOptions.challenge,
                }).then(() => ({
                    creationOptions: publicKeyCredentialCreationOptions,
                    operation: functionRequest.operation,
                    success: true,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })((0, server_1.generateRegistrationOptions)({
                authenticatorSelection: {
                    residentKey: "required",
                    userVerification: "required",
                },
                rpID: callableContext.rawRequest.hostname,
                rpName: callableContext.rawRequest.hostname,
                userID: ((_m = callableContext.auth) === null || _m === void 0 ? void 0 : _m.uid) || "",
                userName: functionRequest.name,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "verify authentication" ? functionRequest.authenticationResponse.response.userHandle !== ((_e = callableContext.auth) === null || _e === void 0 ? void 0 : _e.uid) ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").get().then((userDocumentSnapshot) => ((userDocument) => {
            var _a, _b, _c;
            return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").get().then((priorUserDocumentSnapshot) => ((priorUserDocument) => {
                var _a;
                return priorUserDocument && priorUserDocument.challenge ? (0, server_1.verifyAuthenticationResponse)({
                    authenticator: {
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        counter: userDocument.credentialCounter,
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        credentialID: userDocument.credentialId,
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        credentialPublicKey: userDocument.credentialPublicKey,
                    },
                    expectedChallenge: priorUserDocument.challenge,
                    expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                    expectedRPID: callableContext.rawRequest.hostname,
                    requireUserVerification: true,
                    response: functionRequest.authenticationResponse,
                }).then((verifiedAuthenticationResponse) => {
                    var _a;
                    return verifiedAuthenticationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").update({
                        challenge: firestore_1.FieldValue.delete(),
                        lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                    }).then(() => {
                        var _a, _b;
                        return priorUserDocument.credentialId && priorUserDocument.credentialPublicKey ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                            challenge: firestore_1.FieldValue.delete(),
                        }).then(() => auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }))).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").delete().then(() => auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }))).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }));
                    }).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").delete().then(() => ({
                        code: "not-verified",
                        message: "User not verified.",
                        operation: functionRequest.operation,
                        success: false,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").delete().then(() => ({
                    code: "user-doc-missing-challenge-field",
                    message: "User doc is missing challenge field from prior operation.",
                    operation: functionRequest.operation,
                    success: false,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })(priorUserDocumentSnapshot.data())) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").delete().then(() => ({
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_c = callableContext.auth) === null || _c === void 0 ? void 0 : _c.uid) || "").delete().then(() => ({
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            }));
        })(userDocumentSnapshot.data())) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_f = callableContext.auth) === null || _f === void 0 ? void 0 : _f.uid) || "").update({
            challenge: firestore_1.FieldValue.delete(),
        }).then(() => ({
            code: "no-op",
            message: "No operation is needed.",
            operation: functionRequest.operation,
            success: false,
        })).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "verify reauthentication" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_g = callableContext.auth) === null || _g === void 0 ? void 0 : _g.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _o;
            return userDocument ? userDocument.credentialId && userDocument.credentialPublicKey ? (() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
                return userDocument.challenge ? (0, server_1.verifyAuthenticationResponse)({
                    authenticator: {
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        counter: userDocument.credentialCounter,
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        credentialID: userDocument.credentialId,
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        credentialPublicKey: userDocument.credentialPublicKey,
                    },
                    expectedChallenge: userDocument.challenge,
                    expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                    expectedRPID: callableContext.rawRequest.hostname,
                    requireUserVerification: true,
                    response: functionRequest.authenticationResponse,
                }).then((verifiedAuthenticationResponse) => {
                    var _a, _b;
                    return verifiedAuthenticationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                        challenge: firestore_1.FieldValue.delete(),
                        lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                    }).then(() => {
                        var _a;
                        return auth.createCustomToken(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }));
                    }).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").update({
                        challenge: firestore_1.FieldValue.delete(),
                    }).then(() => ({
                        code: "not-verified",
                        message: "User not verified.",
                        operation: functionRequest.operation,
                        success: false,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }) : {
                    code: "user-doc-missing-challenge-field",
                    message: "User doc is missing challenge field from prior operation.",
                    operation: functionRequest.operation,
                    success: false,
                };
            }))() : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_o = callableContext.auth) === null || _o === void 0 ? void 0 : _o.uid) || "").delete().then(() => ({
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())) : functionRequest.operation === "verify registration" ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_h = callableContext.auth) === null || _h === void 0 ? void 0 : _h.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            var _p, _q;
            return userDocument ? userDocument.challenge ? !userDocument.credentialPublicKey ? (0, server_1.verifyRegistrationResponse)({
                expectedChallenge: userDocument["challenge"],
                expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                expectedRPID: callableContext.rawRequest.hostname,
                requireUserVerification: true,
                response: functionRequest.registrationResponse,
            }).then((verifiedRegistrationResponse) => {
                var _a, _b, _c, _d, _e;
                return verifiedRegistrationResponse.verified ? firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                    challenge: firestore_1.FieldValue.delete(),
                    credentialCounter: (_b = verifiedRegistrationResponse.registrationInfo) === null || _b === void 0 ? void 0 : _b.counter,
                    credentialId: (_c = verifiedRegistrationResponse.registrationInfo) === null || _c === void 0 ? void 0 : _c.credentialID,
                    credentialPublicKey: (_d = verifiedRegistrationResponse.registrationInfo) === null || _d === void 0 ? void 0 : _d.credentialPublicKey,
                    lastVerified: firestore_1.Timestamp.fromDate(new Date()),
                }).then(() => {
                    var _a;
                    return auth.createCustomToken(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").then((customToken) => ({
                        customToken: customToken,
                        operation: functionRequest.operation,
                        success: true,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_e = callableContext.auth) === null || _e === void 0 ? void 0 : _e.uid) || "").delete().then(() => ({
                    code: "not-verified",
                    message: "User not verified.",
                    operation: functionRequest.operation,
                    success: false,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            }) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_p = callableContext.auth) === null || _p === void 0 ? void 0 : _p.uid) || "").update({
                challenge: firestore_1.FieldValue.delete(),
            }).then(() => ({
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("ngxFirebaseWebAuthnUsers").doc(((_q = callableContext.auth) === null || _q === void 0 ? void 0 : _q.uid) || "").delete().then(() => ({
                code: "user-doc-missing-challenge-field",
                message: "User doc is missing challenge field from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : (() => {
            throw new Error("Invalid function request type.");
        })();
    }))((0, auth_1.getAuth)(), (0, firestore_1.getFirestore)()) : {
        code: "missing-auth",
        message: "No user is signed in.",
        operation: functionRequest.operation,
        success: false,
    };
}));
//# sourceMappingURL=index.js.map